our_ai_define:-
  array(buf_tried, 50, 0),
  array(statistic3, 6*9*8, 0),
  array(uniqueness3, 6*9*8, 1.0),
  array(unique_cycle, 9, 1.0),
  G_Percentage := 2,
  G_Positive := 0.

our_ai_init:-
  for(I, 0, 50-1), buf_tried(I):=0, fail.
our_ai_init:-
  G_Dash_or_Point := 0,
  G_Action := 0,
  G_Our_AI_Counter := 0,
  clean_statistic.

clean_statistic:-
  for(I, 0, 6*9*8-1), statistic3(I):=0, uniqueness3(I):=1.0, fail.
clean_statistic:-
  G_FirstDash := G_Time - 1,
  G_Prediction := 0,
  G_Successes := 0.

/*
our_ai_show:-
  write(G_Time-G_FirstDash), nl, nl,
  for(Cycle, 1, 8),
    for(Pos, 0, Cycle-1),
      statistic(5,Cycle,Pos) > 1,
      for(Output, 0, 4),
        statistic(5,Cycle,Pos) < 2*statistic(Output,Cycle,Pos),
        write(Cycle+" "+Pos+" "+string_from_ASCII(Output-1+first_ASCII("x"))+" - "+statistic(5,Cycle,Pos)+" : "+statistic(Output,Cycle,Pos)), nl,
        fail.
*/

our_ai_click(X, Y):-
  I := X//G_ChS,
  (I < 7 ->
    G_Percentage := 1
  else (I < 12 ->
    G_Percentage := 2
  else (I < 24 ->
    G_Percentage := 0
  else (I < 27 ->
     fail
  else (I < 37 ->
    G_Positive := 1
  else (I < 47 ->
    G_Positive := 2
  else (I < 53 ->
    G_Positive := 0
  else
     fail
  ))))))),
  change_pp.

our_ai_show:-
  color_text(_, rgb(0,0,0)),
  text_out(" ", pos(0,10)),
  (G_Zoom_Font=:=1 -> text_out("   ")),
  draw_labels2(G_Percentage =:= 1, " % "),
  draw_labels2(G_Percentage =:= 2, " K:N "),
  draw_labels2(G_Percentage =:= 0, " Uniqueness "),
  text_out(" | "),
  draw_labels2(G_Positive =:= 1, " Positive "),
  draw_labels2(G_Positive =:= 2, " Negative "),
  draw_labels2(G_Positive =:= 0, " Both "),
  fail.

our_ai_show:-
  pen(1, rgb(0, 255 ,0)),
  for(Cycle, 2, 8),
    X := G_ChS*(6*(Cycle-2)+(Cycle-1)*Cycle/2),  % G_Zoom*(100*Cycle+4*Cycle**2-90),
    Y := 2,
    line(X-2, G_Zoom*190, X-2, G_Zoom*640),
    color_text(_, rgb(0,0,255)),
    text_out(Cycle, pos(X, G_Zoom*160)),
    color_text(_, rgb(0,128,0)),
    format_small(unique_cycle(Cycle), Text),
    text_out(Text, pos(X, G_Zoom*190)),
    for(Pos, 0, Cycle-1),
      N := statistic(5,Cycle,Pos),
      N > 1,
      for(Output, 0, 4),
        uniqueness(Output,Cycle,Pos) < 1,
        K := statistic(Output,Cycle,Pos),
        P := statistic(Output,1,0)/statistic(5,1,0),
        (K/N < P ->
          G_Positive =\= 1
        else
          G_Positive =\= 2
        ),
        color_text(_, rgb(0,0,0)),
/*      (better_divisor(Cycle, Output, Pos) ->
          color_text(_, rgb(0,255,0))
        ),
*/
        text_out("", pos(X, G_Zoom*(180+30*Y))),
        make_output(Cycle, Pos, Output),
        (K/N < P ->
          color_text(_, rgb(0,0,255))
        else
          color_text(_, rgb(255,0,0))
        ),
        (G_Percentage =:= 0 ->
          text_out(" "+round(1000*uniqueness(Output,Cycle,Pos)))
        else (G_Percentage =:= 1; (G_Percentage =:= 2, N > 9) ->
          text_out(" "+integer(100*K/N)+"%")
        else
          text_out(" "+K+":"+N)
        )),
        Y := Y + 1,
        fail.

our_ai_show:-
  color_text(_, rgb(255,0,0)),
  text_out("Our AI", pos(G_Zoom*450,G_Zoom*90)),
  color_text(_, rgb(0,0,255)),
  Uniqueness := 0,
  N := statistic(5,1,0),
  calc_uniqueness(Uniqueness, 0.5, 0.5, 1, N),
  (Uniqueness =:= 0 ->
    Uniqueness := 10** (-42)
  ),
  Level1 := Uniqueness**(1/(4*2)),
  find_min(Min),
  Level2 := (N < 150 -> Min**(1/4) else Min**(1/2)),
  Level := min(Level1, Level2),
  % write(Level1 +" "+Level2 +" "+N), nl,
  unique_cycle(0) := Level,
  find_min_list(_, [], List),
  Prediction := (G_Prediction =:= 0 -> "." else string_from_ASCII(G_Prediction-1+first_ASCII("x"))),
  Successes := G_Successes / (G_Time-G_FirstDash),
  Dash_or_Point := (G_Dash_or_Point =:=0 -> "point" else (G_Dash_or_Point =:=3 -> "dash" else "command")),
  text_out("", pos(G_Zoom*50,G_Zoom*650)),
  (List = [] ->
    text_out("No cycles. ")
  else (List = [Min_Cycle] ->
    text_out("The cycle is "+Min_Cycle+". ")
  else
    text_out("The cycles are "+print(List)+". ")
  )),
  text_out("("+Level1+","+Level2+") "),
  text_out("First "+Dash_or_Point+" before " + (G_Time-G_FirstDash) + "."),
  text_out("The prediction is " + Prediction +" by confidence "+ integer(100*G_Best)+"%, successes "+integer(100*Successes)+"%", pos(G_Zoom*50,G_Zoom*700)),
  (G_Yes =:= 0 ->
    color_text(_, rgb(255,0,0)),
    text_out(" (no)")
  ),
  fail.

better_divisor(Cycle, Output, Pos):-
  divisor(Cycle2, Cycle),
  for(Pos2, Pos mod Cycle2, Cycle-1, step(Cycle2)),
    2*uniqueness(Output,Cycle,Pos) > uniqueness(Output,Cycle2,Pos2).

divisor(Cycle2, Cycle):-
  for(Cycle2, 2, Cycle-1),
    Cycle mod Cycle2 =:= 0.

make_output(Cycle, Pos, Output):-
  Pos2 := (Output =:= 4 -> (Pos-1) mod Cycle else Pos),
  for(I, 0, Cycle-1),
    (I =\= Pos2 ->
      text_out(".")
    else (Output =:= 0 ->
      text_out("0")
    else (Output =:= 4 ->
      color_text(_, rgb(0,128,0)),
      text_out("T"),
      color_text(_, rgb(0,0,0))
    else
      text_out(string_from_ASCII(Output-1+first_ASCII("x")))
    ))),
    fail.
make_output(_, _, _).

our_ai_action(Action):-
  Action := G_Action,
  (buf_tried(G_Time mod 50) /\ 2**Action =\= 0 ->
    Action := 0
  ).

tried(Last):-
  Last =:= 0,
  buf_tried((G_Time-1) mod 50) /\ 2**G_Dash_or_Point =\= 0.

our_ai_thinks:-
  (G_Our_AI_Counter =:= 0 ->
    G_Action := (G_Action + 1) mod 4,
    G_Our_AI_Counter := 15 % + random(10)
  else
    G_Our_AI_Counter := G_Our_AI_Counter - 1
  ),
  Last := buf_actions((G_Time-1) mod 50),
  (G_Dash_or_Point =\= Last, not(tried(Last)); G_Time =:= 1 ->
    Tried := buf_tried((G_Time-1) mod 50),
    G_Dash_or_Point := (Last =:= 0 -> (One := find_first_1_in(Tried) -> One else 0) else Last),
    clean_statistic,
    Output := buf_views((G_Time-1) mod 50),
    make_statistic(Output, 0)
  ),
  Output := buf_views(G_Time mod 50),
  make_statistic(Output, G_Time-G_FirstDash),
  fail.

our_ai_thinks:-
  (G_Prediction =:= buf_views(G_Time mod 50) ->
    G_Successes := G_Successes + 1,
    G_Yes := 1
  else
    G_Yes := 0
  ),
  G_Prediction := 0,
  G_Best := 0,
  for(Cycle, 1, 8),
    Pos := (G_Time+1-G_FirstDash) mod Cycle,
    statistic(5,Cycle,Pos) > 1,
    for(Output, 0, 3),
      statistic(5,Cycle,Pos) < 2*statistic(Output,Cycle,Pos),
      % not(better_divisor(Cycle, Output, Pos)),
      Division := statistic(Output,Cycle,Pos)/statistic(5,Cycle,Pos),
      (Division > G_Best ->
        G_Prediction := Output,
        G_Best := Division
      ),
      fail.
our_ai_thinks.

make_statistic(Output, Moment):-
  for(Cycle, 1, 8),
    Pos := Moment mod Cycle,
    statistic(5,Cycle,Pos) ::= statistic(5,Cycle,Pos) + 1,
    statistic(Output,Cycle,Pos) ::= statistic(Output,Cycle,Pos) + 1,
    (buf_tried((G_Time-1) mod 50) /\ 2**G_Dash_or_Point =\= 0 ->
      statistic(4,Cycle,Pos) ::= statistic(4,Cycle,Pos) + 1
    ),
    fail.
make_statistic(_, _):-
  for(Output, 0, 4),
    P := statistic(Output,1,0)/statistic(5,1,0),
    Q := 1-P,
    for(Cycle, 2, 8),
      for(Pos, 0, Cycle-1),
        N := statistic(5,Cycle,Pos),
        N > 1,
        Uniqueness := 0,
        K := statistic(Output,Cycle,Pos),
        (K/N < P ->
          calc_uniqueness(Uniqueness, P, Q, K, N)
        else
          K := N-K,
          calc_uniqueness(Uniqueness, Q, P, K, N)
        ),
        (Uniqueness =:= 0 ->
          uniqueness(Output,Cycle,Pos) ::= 10** (-42)
        else (Uniqueness < 0.25 ->
          uniqueness(Output,Cycle,Pos) ::= 4 * Uniqueness
        else
          uniqueness(Output,Cycle,Pos) ::= 1.0
        )),
        fail.
make_statistic(_, _):-
  for(Cycle, 2, 8),
    make_uniqueness(Cycle, Uniqueness),
    unique_cycle(Cycle) := Uniqueness,
    fail.
make_statistic(_, _).

calc_uniqueness(Uniqueness, P, Q, K1, N1):-
  (N1 > 100 ->
    N := 100,
    K2 := ceiling(K1/(N1/100))
  else
    N := N1,
    K2 := K1
  ),
  Combinations := 1,
  for(K, 0, K2),
    Uniqueness := Uniqueness + Combinations * P**K * Q**(N-K),
    Combinations := Combinations * (N-K)/(K+1),  % write("C("+N+","+(K+1)+")="+Combinations), nl,
    fail.
calc_uniqueness(Uniqueness, P, Q, K1, N1):-
  (N1 > 100 ->
    Uniqueness := Uniqueness**(N1/100)
  ).

make_uniqueness(Cycle, Uniqueness):-
  Uniqueness := 1,
  for(Output, 0, 4),
    for(Pos, 0, Cycle-1),
      (Uniqueness > uniqueness(Output,Cycle,Pos) -> 
        Uniqueness := uniqueness(Output,Cycle,Pos)
      ),
      fail.
make_uniqueness(_, _).

format_small(Num, Text):-
  (Num < 10** (-42) ->
    Text := "E-42 ..."
  else (Num < 0.001 ->
    Digits := integer(log10(Num))-1,
    Text := "E"+Digits+" "+integer(Num/10**Digits)+".0"
    %write(Num+" "+Digits+" "+Text), nl
  else
    Text := integer(1000*Num)/1000
  )).

find_min_list(Min_Cycle, List1, List2):-
  Min_Cycle := 0,
  for(Cycle, 2, 8),
    not(multiple_in_list(Cycle, List1)),
    (unique_cycle(Cycle) < unique_cycle(Min_Cycle) ->
      Min_Cycle := Cycle
    ),
    fail.
find_min_list(Min_Cycle, List1, List2):-
  (Min_Cycle > 0 ->
    append(List1,[Min_Cycle],L),
    find_min_list(_, L, List2)
  else
    List2 = List1
  ).

multiple_in_list(Cycle, List):-
  member(E, List),
  (E =< Cycle ->
    Cycle mod E =:= 0
  else
    E mod Cycle =:= 0
  ).

find_min(Min):-
  Min := 1,
  for(Cycle, 2, 8),
    (unique_cycle(Cycle) < Min ->
      Min := unique_cycle(Cycle)
    ),
    fail.
find_min(Min).
